## plastimatch 1.7.3+dfsg.1

=== CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  Welcome to the Plastimatch CMakeLists.txt file
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (plastimatch)

## The version here should be equal to the "most recent release"
set (PLM_VERSION_MAJOR "1")
set (PLM_VERSION_MINOR "7")
set (PLM_VERSION_PATCH "3")

##-----------------------------------------------------------------------------
##  Set up CMake defaults
##-----------------------------------------------------------------------------
cmake_minimum_required (VERSION 2.8.12)

# CMP0003: Libraries linked via full path no longer produce linker search
#  paths.
if (POLICY CMP0003)
  cmake_policy (SET CMP0003 NEW)
endif ()
# CMP0012: if() recognizes numbers and boolean constants.
# GCS 2012-03-04: This is added to suppress ITK warning
if (POLICY CMP0012)
  cmake_policy (SET CMP0012 NEW)
endif ()
# CMP0017: Prefer files from the CMake module directory when including
# from there.
if (POLICY CMP0017)
  cmake_policy (SET CMP0017 NEW)
endif ()
# CMP0054: Quoted variables no longer dereferenced
# GCS 2017-11-02: This is added to suppress Qt warnings
if (POLICY CMP0054)
  cmake_policy (SET CMP0054 NEW)
endif ()

##-----------------------------------------------------------------------------
##  CMake include files
##-----------------------------------------------------------------------------
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

##-----------------------------------------------------------------------------
##  Prevent in-source build
##-----------------------------------------------------------------------------
include (PreventInSourceBuilds)

##-----------------------------------------------------------------------------
##  Macros and functions used in this script
##-----------------------------------------------------------------------------
include (PlmMacros)
include (SuperbuildOptions)

##-----------------------------------------------------------------------------
##  Define default build type as Release
##-----------------------------------------------------------------------------
if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Choose the type of build, options are: Debug Release
      RelWithDebInfo MinSizeRel." FORCE)
endif ()
sb_variable (CMAKE_BUILD_TYPE)

##-----------------------------------------------------------------------------
##  Define plastimatch configuration variables
##-----------------------------------------------------------------------------
sb_option (PLM_CONFIG_ENABLE_CUDA "Set to ON to allow build with CUDA" ON)
option (PLM_CONFIG_ENABLE_DCMTK "Set to ON to allow build with DCMTK" ON)
option (PLM_CONFIG_ENABLE_FATM "Set to ON to allow building fatm" OFF)
option (PLM_CONFIG_ENABLE_MONDOSHOT "Set to ON to allow building mondoshot" OFF)
sb_option (PLM_CONFIG_ENABLE_OPENCL "Set to ON to allow build with OpenCL" ON)
sb_option (PLM_CONFIG_ENABLE_OPENMP "Set to ON to allow build with OpenMP" ON)
sb_option (PLM_CONFIG_ENABLE_OPT4D "Set to ON to allow build with Opt4D" OFF)
option (PLM_CONFIG_ENABLE_PLASTIMATCH "Set to ON to allow building plastimatch" ON)
option (PLM_CONFIG_ENABLE_QT "Set to ON to allow build with QT" ON)
sb_option (PLM_CONFIG_ENABLE_SSE2 "Set to ON to allow build with SSE" ON)
option (PLM_CONFIG_ENABLE_MATLAB "Set to ON to allow build of Matlab plugins" OFF)
sb_option (PLM_CONFIG_ENABLE_VISCOUS
  "Set to ON to allow build of experimental viscous fluid registration algorithm" OFF)
sb_option (PLM_CONFIG_ENABLE_PLASTIMATCH_QT
  "Set to ON to allow build of experimental plastimatch_qt executable" OFF)

option (PLM_CONFIG_BUILD_QT_PLUGINS "Set to ON to allow build of QT4 Designer Plugins" OFF)
sb_option (PLM_CONFIG_DEBIAN_BUILD "Set to ON to configure build for debian" OFF)
option (PLM_CONFIG_LIBRARY_BUILD "Set to ON to build only libraries" OFF)
option (PLM_CONFIG_NOMANIFEST
  "Set to ON to build windows DLLs without manifests" OFF)
option (PLM_CONFIG_ENABLE_SUPERBUILD
  "Set to ON to allow src/plastimatch to be built using nested superbuild" ON)

# Plastimatch software configuration options
option (PLM_CONFIG_CLANG_COMPLETE
  "Generate .clang_complete for hipster Vim-ers" OFF)
sb_option (PLM_CONFIG_PREFER_PATCHED_ITK
  "Prefer to use the patched version of certain ITK files" ON)
sb_option (PLM_CONFIG_VOL_LIST
  "Native support for volumes with irregular slice thicknesses" OFF)

# Plastimatch legacy options
sb_option (PLM_CONFIG_LEGACY_BSPLINE_EXTEND
  "Use legacy code for extending b-spline domain" OFF)
sb_option (PLM_CONFIG_LEGACY_BSPLINE_XFORM_IO
  "Use legacy code for reading and writing b-spline xform files" OFF)
sb_option (PLM_CONFIG_LEGACY_CUDA_DELAYLOAD
  "Use legacy code for verifying CUDA runtime" ON)
sb_option (PLM_CONFIG_LEGACY_DRR_CUDA_TEXTURE
  "Use legacy 1D texture for CUDA DRR generation" OFF)
sb_option (PLM_CONFIG_LEGACY_MI_METRIC
  "For ITK metrics, the legacy implementation of the mi metric is Viola-Wells to Mattes" OFF)
sb_option (PLM_CONFIG_LEGACY_PROJ_GEO
  "Use legacy method for specifying projection geometry" ON)
sb_option (PLM_CONFIG_LEGACY_RAY_TRACE_EXACT
  "Use legacy algorithm for exact ray tracing" OFF)

# Compile and link options
sb_option (PLM_CUDA_ALL_DEVICES
  "Generate GPU code for all compute capabilities?" OFF)
sb_option (BUILD_SHARED_LIBS "Build plastimatch as shared library" OFF)

# Choose whether to build against included and/or superbuild libraries
# instead of system libraries
sb_option_enum (PLM_SYSTEM_DCMTK "Prefer DCMTK provided by operating system"
  PREFERRED
  NO PREFERRED YES)
sb_option (PLM_PREFER_SYSTEM_DLIB
    "Prefer the system dlib over the included dlib" ON)
sb_option_enum (PLM_SYSTEM_ITK "Prefer ITK provided by operating system"
  PREFERRED
  NO PREFERRED YES)

# Testing
sb_option (PLM_BUILD_TESTING "Enable regression testing" ON)

# Installer Options
option (PLM_INSTALL_RPATH "Add full RPATH to install" OFF)
sb_option (PLM_CONFIG_INSTALL_LIBRARIES "Include libraries in install" ON)

# Packaging
option (PLM_PACKAGE_32BIT
    "Set this when building 32-bit packages on a 64-bit machine" OFF)
option (PLM_PACKAGE_NSIS "Set to ON when packaging binaries with NSIS" OFF)
option (PLM_PACKAGE_WIX "Set to ON when packaging binaries with WIX" ON)
sb_option (PLM_PACKAGE_LEGACY_CMAKE_CONFIG
    "Use the old code for creating PlastimatchConfig.cmake and friends" OFF)

# Use legacy packaging if cmake version is < 3.0
if (CMAKE_VERSION VERSION_LESS "3.0")
  set (PLM_PACKAGE_LEGACY_CMAKE_CONFIG ON CACHE BOOL "Use legacy packaging routines")
endif ()

# Override some options if library build is selected
if (PLM_CONFIG_LIBRARY_BUILD)
  set (PLM_CONFIG_ENABLE_FATM OFF)
  set (PLM_CONFIG_ENABLE_MONDOSHOT OFF)
endif ()

##-----------------------------------------------------------------------------
##  Setup important locations
##-----------------------------------------------------------------------------
sb_set (PLM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}")
sb_set (PLM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

# Offer the user the choice of overriding the installation directories
set (PLM_INSTALL_LIB_DIR lib CACHE PATH
  "Installation directory for libraries")
set (PLM_INSTALL_BIN_DIR bin CACHE PATH
  "Installation directory for executables")
set (PLM_INSTALL_INCLUDE_DIR include/plastimatch CACHE PATH
  "Installation directory for header files")
if (WIN32 AND NOT CYGWIN)
  set (DEF_INSTALL_CMAKE_DIR CMake)
else()
  set (DEF_INSTALL_CMAKE_DIR lib/cmake/plastimatch)
endif()
set (PLM_INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH
  "Installation directory for CMake files")
mark_as_advanced (
  PLM_INSTALL_LIB_DIR
  PLM_INSTALL_BIN_DIR
  PLM_INSTALL_INCLUDE_DIR
  PLM_INSTALL_CMAKE_DIR)


# GCS 2015-07-08.  The below workflow is described here:
#   http://www.cmake.org/Wiki/CMake/Tutorials/How_to_create_a_ProjectConfig.cmake_file
# However, it creates install targets with absolute paths, which is
# not allowed for NSIS targets.
# It is possible this is resolved by newer documentation, which is referred
# by the above link:
#   http://www.cmake.org/cmake/help/git-master/manual/cmake-packages.7.html#creating-packages
# Needs further investigation

# Make relative install paths absolute (needed later on)
if (PLM_PACKAGE_LEGACY_CMAKE_CONFIG)
foreach (p LIB BIN INCLUDE CMAKE)
  set (var PLM_INSTALL_${p}_DIR)
  if (NOT IS_ABSOLUTE "${${var}}")
    set (${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif ()
endforeach ()
endif ()

##-----------------------------------------------------------------------------
##  CMake include files
##-----------------------------------------------------------------------------
include (CTest)
include (CheckFunctionExists)

# http://www.cmake.org/pipermail/cmake/2008-December/025886.html
# http://www.cmake.org/Bug/view.php?id=15117
set (CMAKE_INSTALL_OPENMP_LIBRARIES ON)
if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_LESS 3.1)
    include (InstallRequiredSystemLibrariesPatched)
else ()
    include (InstallRequiredSystemLibraries)
endif ()

# Superbuild
include (ExternalProject)

##-----------------------------------------------------------------------------
##  Disable spurious warnings on MSVC (version 8 & higher)
##-----------------------------------------------------------------------------
if (WIN32 AND NOT CYGWIN AND NOT MINGW)
  add_definitions(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    # _SCL_SECURE_NO_DEPRECATE became _SCL_SECURE_NO_WARNINGS in VC9
    -D_SCL_SECURE_NO_WARNINGS
    )
endif ()

##-----------------------------------------------------------------------------
##  Compile with -fPIC is needed for amd64 and other platforms
##-----------------------------------------------------------------------------
plm_set_pic_flags ()

##-----------------------------------------------------------------------------
##  Extra paths
##-----------------------------------------------------------------------------
set (PLM_TESTING_SOURCE_DIR "${CMAKE_SOURCE_DIR}/Testing")
set (PLM_TESTING_DATA_DIR "${CMAKE_SOURCE_DIR}/Testing/Data")
set (PLM_TESTING_DOWNLOAD_DATA_DIR "${CMAKE_BINARY_DIR}/TestData")
set (PLM_BUILD_TESTING_DIR "${CMAKE_BINARY_DIR}/Testing")

##-----------------------------------------------------------------------------
##  Set the math library
##-----------------------------------------------------------------------------
if (UNIX)
  set (MATH_LIB -lm)
else ()
  set (MATH_LIB)
endif ()

##-----------------------------------------------------------------------------
##  Libdl
##-----------------------------------------------------------------------------
# Some systems such as pcBSD don't have libdl
find_library (LIBDL_FOUND dl)

##-----------------------------------------------------------------------------
##  DCMTK
##-----------------------------------------------------------------------------
## If it is a modern version of DCMTK, such as found in Slicer build,
## it will have a working version of DCMTKConfig.cmake.
## In this case, we can use the modern find_package variant.
## Otherwise we use the old hacked version of FindDCMTK.cmake.
if (PLM_CONFIG_ENABLE_DCMTK)
  if (PLM_SYSTEM_DCMTK STREQUAL "YES")
    find_package (DCMTK_wrap REQUIRED)
  elseif (PLM_SYSTEM_DCMTK STREQUAL "PREFERRED")
    find_package (DCMTK_wrap QUIET)
  endif ()

  if (NOT DCMTK_FOUND AND NOT PLM_SYSTEM_DCMTK STREQUAL "YES")
    include (SuperBuild/External_DCMTK.cmake)

=== Testing/CMakeLists.txt ===
project (PLM_Testing)

## -------------------------------------------------------------------------
## TODO: create targets like "make check plm-reg-bsp-a"
## http://stackoverflow.com/questions/733475/cmake-ctest-make-test-doesnt-build-tests
## -------------------------------------------------------------------------

## -------------------------------------------------------------------------
## Note on test dependencies.  Some versions of cmake (e.g. Windows cmake 
## version 2.8.2) have a bug where the dependency graph is created 
## incorrectly.  Specifically, if B depends on A, and C depends on 
## both A and B, the graph will be generated incorrectly.  
## -------------------------------------------------------------------------

## -------------------------------------------------------------------------
## Test and data download options
## -------------------------------------------------------------------------
option (PLM_REDUCED_TESTS 
  "Run fewer tests (used when debugging tests)" OFF)
option (PLM_DOWNLOAD_TEST_DATA
  "Additional testing data (download from internet)" OFF)

##-----------------------------------------------------------------------------
## Configure test input files
##-----------------------------------------------------------------------------
set (CONFIG_FILE_LIST
  "plm-bsp-mse-c.txt"
  "plm-bsp-mse-h.txt"
  "plm-bsp-mse-k.txt"
  "plm-bsp-mse-l.txt"
  "plm-bsp-mi-c.txt"
  "plm-bsp-mi-k.txt"
  "plm-bsp-gm-k.txt"
  "plm-bsp-dmap-k.txt"
  "plm-bsp-sm-multi-a.txt"
  "plm-bsp-cuda.txt"
  "plm-bsp-rect.txt"
  "plm-bsp-resume.txt"
  "plm-bsp-logfile.txt"
  "plm-bsp-dcos-a.txt"
  "plm-bsp-dcos-b.txt"
  "plm-bsp-dcos-c.txt"
  "plm-bsp-dcos-d.txt"
  "plm-bsp-dcos-e.txt"
  "plm-bsp-dcos-f.txt"
  "plm-bsp-landmark-a.txt"
  "plm-bsp-landmark-b.txt"
  "plm-bsp-landmark-c.txt"
  "plm-bsp-landmark-d.txt"
  "plm-bsp-landmark-e.txt"
  "plm-bsp-double.txt"
  "plm-bsp-regularize-numeric.txt"
  "plm-reg-align-center.txt"
  "plm-reg-itk-translation.txt"
  "plm-reg-roi-a.txt"
  "plm-reg-roi-b.txt"
  "plm-reg-roi-c.txt"
  "plm-reg-roi-d.txt"
  "plm-reg-roi-e.txt"
  "plm-reg-stiffness-a.txt"
  "plm-reg-multi-a.txt"
  "plm-reg-multi-b.txt"
  "plm-reg-dv-itk-translation.txt"
  "plm-reg-itk-rigid-a.txt"
  "plm-reg-itk-rigid-b.txt"
  "plm-reg-itk-similarity.txt"
  "plm-reg-itk-bspline.txt"
  "plm-reg-process-a.txt"
  "plm-reg-trans-a.txt"
  "plm-reg-trans-b.txt"
  "plm-reg-trans-mi-a.txt"
  "plm-reg-autores-a.txt"
  "plm-reg-autores-b.txt"
  "plm-reg-gw-a.txt"
  "proton-dose-1.txt"
  "proton-dose-2.txt"
  "proton-dose-4.txt"
  "proton-dose-5a.txt"
  "proton-dose-5d.txt"
  "proton-dose-6a.txt"
  "speedtest-a.txt"
  "wed-a.txt"
  "wed-b.txt"
  "wed-c.txt"
)
foreach (CONFIG_FILE ${CONFIG_FILE_LIST})
    string (REGEX REPLACE "\\.txt$" "" PLM_TEST_NAME ${CONFIG_FILE})
    configure_file ("${PLM_TESTING_DATA_DIR}/${CONFIG_FILE}"
	"${PLM_BUILD_TESTING_DIR}/${CONFIG_FILE}"
	@ONLY)
endforeach ()

## -------------------------------------------------------------------------
## Testing macros
## -------------------------------------------------------------------------
macro (plmtest_check_interval 
    test_name stdout_file regex_string lower_thresh upper_thresh)
  string (REPLACE "\\" "\\\\" regex_escaped "${regex_string}")
  add_test (${test_name}
    ${CMAKE_COMMAND} 
    "-DINFILE=${stdout_file}"
    "-DREGEX=${regex_escaped}"
    "-DLOWER_THRESH=${lower_thresh}"
    "-DUPPER_THRESH=${upper_thresh}"
    -P "${PLM_TESTING_SOURCE_DIR}/PlmCheckInterval.cmake"
    )
endmacro ()

macro (plmtest_check_string
    test_name stdout_file regex_string match_string)
  string (REPLACE "\\" "\\\\" regex_escaped "${regex_string}")
  add_test (${test_name}
    ${CMAKE_COMMAND} 
    "-DINFILE=${stdout_file}"
    "-DREGEX=${regex_escaped}"
    "-DMATCH_STRING=${match_string}"
    -P "${PLM_TESTING_SOURCE_DIR}/PlmCheckString.cmake"
    )
endmacro ()

macro (plmtest_debug test_name stdout_file stderr_file)
  add_test (${test_name}
    ${CMAKE_COMMAND} 
    "-DSTDOUT_FILE=${stdout_file}"
    "-DSTDERR_FILE=${stderr_file}"
    -P "${PLM_TESTING_SOURCE_DIR}/PlmTestDebug.cmake"
    )
endmacro ()

## -------------------------------------------------------------------------
## Download data sets
## -------------------------------------------------------------------------
macro (plm_download_and_extract DOWNLOAD_URL DOWNLOAD_FILENAME DOWNLOAD_DIR)
  if (NOT IS_DIRECTORY "${PLM_TESTING_DOWNLOAD_DATA_DIR}")
    file (MAKE_DIRECTORY "${PLM_TESTING_DOWNLOAD_DATA_DIR}")
  endif ()
  set (download_retries 3)
  while (NOT EXISTS ${DOWNLOAD_FILENAME} AND download_retries)
    message (STATUS "Downloading test data: ${DOWNLOAD_FILENAME}")
    file (DOWNLOAD "${DOWNLOAD_URL}" "${DOWNLOAD_FILENAME}"
      STATUS download_status)
    message (STATUS "Download status[${download_retries}]: ${download_status}")
    list (GET download_status 0 dl_status)
    if (dl_status)
      math (EXPR download_retries "${download_retries}-1")
    endif ()
  endwhile ()
  if (NOT EXISTS ${DOWNLOAD_DIR})
    message (STATUS "Untarring test data: ${DOWNLOAD_FILENAME}")
    execute_process (
      COMMAND 
      ${CMAKE_COMMAND} "-E" "tar" "xvzf" "${DOWNLOAD_FILENAME}"
      WORKING_DIRECTORY ${PLM_BUILD_TESTING_DIR}
      RESULT_VARIABLE untar_result
      OUTPUT_VARIABLE untar_output
      ERROR_VARIABLE untar_error)
    message (STATUS "Untar command returned: ${untar_result}\n${untar_output}\n${untar_error}")
  endif ()
endmacro ()

if (PLM_DOWNLOAD_TEST_DATA)

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-33-structures.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-33-structures.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-33-structures")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-aw-4.4-foot.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-aw-4.4-foot.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-aw-4.4-foot")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-corvus-6.2.2.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-corvus-6.2.2.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-corvus-6.2.2")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-pinnacle3-8.2g-rando.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-pinnacle3-8.2g-rando.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-pinnacle3-8.2g-rando")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-xio-4.33.02-chest-phantom.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-xio-4.33.02-chest-phantom.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-xio-4.33.02-chest-phantom")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/dicomrt-xio-4.60-irregular-spacing.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/dicomrt-xio-4.60-irregular-spacing.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/dicomrt-xio-4.60-irregular-spacing")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/headphantom.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/headphantom.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/headphantom")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/rtog-corvus-6.2.2.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/rtog-corvus-6.2.2.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/rtog-corvus-6.2.2")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/varian-catphan-subset.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/varian-catphan-subset.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/varian-catphan-subset")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/xio-4.33.02-chest-phantom.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/xio-4.33.02-chest-phantom.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/xio-4.33.02-chest-phantom")

  plm_download_and_extract (
    "https://sourceforge.net/projects/plastimatch/files/Sample%20Data/xio-4.60-irregular-spacing.tar.gz/download"
    "${PLM_TESTING_DOWNLOAD_DATA_DIR}/xio-4.60-irregular-spacing.tar.gz"
    "${PLM_BUILD_TESTING_DIR}/xio-4.60-irregular-spacing")

endif ()

## -------------------------------------------------------------------------
## Custom test command
## -------------------------------------------------------------------------
add_custom_target (speedtest
  ${CMAKE_COMMAND} 
  -DPLM_PLASTIMATCH_PATH="${PLM_PLASTIMATCH_PATH}"
  -DPLM_BUILD_TESTING_DIR="${PLM_BUILD_TESTING_DIR}"
  -P "${PLM_TESTING_SOURCE_DIR}/PlmSpeedTest.cmake"
  )

## -------------------------------------------------------------------------
## Test cases
## -------------------------------------------------------------------------
## Create synthetic images
##   black-1           All black, slightly different geometry
##   donut-1           Centered donut
##   gabor-xx          Fibonacci Gabor
##   gauss-1           Centered gauss
##   gauss-2           Off-center gauss
##   gauss-3           Inverted gauss
##   gauss-4           Gauss with inverted pixel spacing
##   gauss-5           Even more off-center gauss
##   gauss-6           Off-center gauss, in off-center world coordinates
##   gauss-7           Off-center gauss with wider sigma
##   gauss-ushort-1    Centered gauss, ushort
##   gauss-ushort-2    Off-center gauss, ushort
##   lung-1            Synthetic lung, tumor position 0
##   lung-2            Synthetic lung, tumor position -5
##   gw-lung-a         Synthetic lung, tumor position -5, in gw dir
##   gw-lung-b         Synthetic lung, tumor position 0, in gw dir
##   gw-lung-c         Synthetic lung, tumor position +5, in gw dir
##   ptv-1             rect PTV target for dose calculation
##   ptv-2             rect PTV target for dose calculation, smaller geometry
##   rect-1            Inverted rect, centered
##   rect-2            Standard rect, off-center
##   rect-3            Standard rect, centered
##   rect-4            Uchar rect, centered
##   rect-5            Standard rect, centered, direction cosines alt-1
##   rect-6            Standard rect, centered, direction cosines alt-2
##   rect-7            Standard rect, centered, direction cosines alt-3
##   rect-8            Uchar rect, off-center
##   rect-9            Uchar rect, centered, higher resolution
##   rect-10-roi-1
##   rect-10-roi-2
##   rect-10
##   rect-11
##   rect-11-roi
##   rect-12           Small rect, bg=0, fg=10
##   rect-13           Small rect, bg=0, fg=11
##   rect-14           Small, off-center rect, bg=0, fg=10
##   rect-15           Standard rect, slicer direction cosines
##   rect-16           Off-center rect, slicer direction cosines
##   rect-17           Water phantom, resolution 5x5x5, for dose calculation
##   rect-18	       Water phantom, very low resolution 20x20, dose calc.
##   rect-19	       Standard, but larger rectangle
##   rectarr-01        Two rectangles, both centered
##   rectarr-02        Two rectangles, lower rect offset
##   rectarr-m-01      Upper mask for rectarr-01 and rectarr-02
##   rectarr-m-02      Lower mask for rectarr-01 and rectarr-02
##   rectarr-03        Two rectangles, both centered (for testing gamma)
##   rectarr-04        Two rectangles, lower rect offset (for testing gamma)
##   roi-1             left = 0, right = 1
##   rgc-1             rect range compensator for dose calculation
##   sphere-1          Uchar sphere, bg=0, fg=255
##   sphere-2          Standard sphere, centered
##   sphere-3          Standard, bg=0, fg=1
##   sphere-4          Standard, radius = 150
## -------------------------------------------------------------------------
set (SYNTH_MHA_SIZE 38)

plm_add_test (
  "black-1"

=== src/plastimatch/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  Welcome to the Plastimatch CMakeLists.txt file
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch)
cmake_minimum_required (VERSION 2.8.12)

##-----------------------------------------------------------------------------
##  CMake include files
##-----------------------------------------------------------------------------
set (CMAKE_MODULE_PATH "${PLM_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include (PlmMacros)

##-----------------------------------------------------------------------------
##  Processor and OS characteristics
##    32-bit or 64-bit machine
##    Endian-ness
##    Machine precision
##    Processor type
##-----------------------------------------------------------------------------
include (CheckCharSign)
include (CheckEpsilon)
# No need to check this yet.  Doing so may force C++11 compiler flag,
# which causes build error on earlier version of ITK.
#include (CheckNullptr)
include (CheckTypeSize)
include (TestBigEndian)

check_type_size ("unsigned int" CMAKE_SIZEOF_UINT)
check_type_size ("unsigned long" CMAKE_SIZEOF_ULONG)
check_type_size ("size_t" CMAKE_SIZEOF_SIZE_T)
if (NOT APPLE)
  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set (MACHINE_IS_32_BIT TRUE)
    set (MACHINE_IS_64_BIT FALSE)
    message (STATUS "Machine is 32-bit")
  else ()
    set (MACHINE_IS_32_BIT FALSE)
    set (MACHINE_IS_64_BIT TRUE)
    message (STATUS "Machine is 64-bit")
  endif ()
endif ()

test_big_endian (PLM_BIG_ENDIAN)
check_epsilon (MACHINE_EPS)
check_char_sign (CHAR_SIGN)
message (STATUS "Checking host processor: ${CMAKE_HOST_SYSTEM_PROCESSOR}")
message (STATUS "Checking target processor: ${CMAKE_SYSTEM_PROCESSOR}")
message (STATUS "Checking epsilon: ${MACHINE_EPS}")
message (STATUS "Checking sign of char: ${CHAR_SIGN}")

include (CheckIncludeFiles)
check_include_files ("stdint.h" HAVE_STDINT_H)
check_include_files ("sys/stat.h" HAVE_SYS_STAT_H)

##-----------------------------------------------------------------------------
##  Figure out if we should use gdcm or dcmtk
##-----------------------------------------------------------------------------
find_package (DCMTK_wrap)

set (PLM_DCM_USE_DCMTK 0)
set (PLM_DCM_USE_GDCM1 0)
set (PLM_DCM_USE_GDCM2 0)

if (DCMTK_FOUND)
  set (PLM_DCM_USE_DCMTK 1)
elseif (GDCM_VERSION_2)
  set (PLM_DCM_USE_GDCM2 1)
else ()
  set (PLM_DCM_USE_GDCM1 1)
endif ()

##-----------------------------------------------------------------------------
##  Give a warning for obsolete dicom libraries
##-----------------------------------------------------------------------------
# If the user only has gdcm 2.x, give a warning
if (PLM_DCM_USE_GDCM2)
  message (WARNING "Plastimatch is being built with GDCM 2.X.  DICOM-RT functions are disabled.")
elseif (PLM_DCM_USE_GDCM1)
  message (WARNING "Plastimatch is being built with GDCM 1.X.  Certain features of DICOM-RT are disabled.")
endif ()

##-----------------------------------------------------------------------------
##  dlib
##-----------------------------------------------------------------------------
if (PLM_PREFER_SYSTEM_DLIB)
  # Use this version if you want to use the internal cmake find.
  # The internal version has issue finding the correct BLAS library
  # for Debian, so we prefer Debian version.
  # find_package (Dlib)

  # A previous version of the Debian cmake find was broken in a way that 
  # could be worked around by setting dlib_BINARY_DIR.  However, modern
  # dlibConfig.cmake scripts do not have this problem.
  ##  set (dlib_BINARY_DIR 1)
  find_package (dlib QUIET)
endif ()
set (DLIB_HAVE_LIBRARY FALSE)
if (dlib_FOUND)
  set (DLIB_INCLUDE_DIR ${dlib_INCLUDE_DIR})
  set (DLIB_LIBRARIES ${dlib_LIBRARIES})
  set (DLIB_FOUND TRUE)
  if (DLIB_LIBRARIES)
    set (DLIB_HAVE_LIBRARY TRUE)
  endif ()
else ()
  set (DLIB_INCLUDE_DIR "${PLM_SOURCE_DIR}/libs/dlib-19.1")
  set (DLIB_LIBRARIES "")
endif ()

##-----------------------------------------------------------------------------
##  ransac
##-----------------------------------------------------------------------------
set (RANSAC_INCLUDE_DIRS
  "${PLM_SOURCE_DIR}/libs/ransac"
  "${PLM_SOURCE_DIR}/libs/ransac/Common")

##-----------------------------------------------------------------------------
##  ITK
##-----------------------------------------------------------------------------
if (PLM_USING_SUPERBUILD)
  set (PLM_CONFIG_USE_PATCHED_ITK 0)
  find_package (ITK REQUIRED
    PATHS "/usr/lib64/cmake/InsightToolkit")
  include (HandleITK)
  include (HandleVXL)
endif ()

##-----------------------------------------------------------------------------
##  Hack for superbuild
##-----------------------------------------------------------------------------
link_directories (${PLM_BINARY_DIR})

##-----------------------------------------------------------------------------
##  Libraries
##-----------------------------------------------------------------------------
set (PLASTIMATCH_LIBS
  plmclp
#  plmscript
  plmsegment
  plmregister
  plmreconstruct
  plmdose
  plmutil
  plmbase
  plmsys
  ${ITK_LIBRARIES}
  devillard
  nkidecompress
#  lua
  ${MATH_LIB}
  )

if (CUDA_FOUND AND NOT PLM_USE_GPU_PLUGINS)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmcuda)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmreconstructcuda)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmregistercuda)
endif ()

if (DCMTK_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${DCMTK_LIBRARIES})
endif ()

if (DLIB_LIBRARIES)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${DLIB_LIBRARIES})
endif ()

if (FFTW_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${FFTW_LIBRARIES})
endif ()

if (KAZE_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${KAZE_LIBRARIES})
endif ()

if (LIBDL_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} dl)
endif ()

if (NLOPT_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${NLOPT_LIBRARIES})
endif ()

if (OPENCL_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} plmopencl)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${OPENCL_LIBRARIES})
endif ()

if (OPENMP_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${OPENMP_LIBRARIES})
endif ()

if (SPECFUN_FOUND)
  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} specfun)
endif ()

### Let QT applications add this themselves
#if (QT4_FOUND)
#  set (PLASTIMATCH_LIBS ${PLASTIMATCH_LIBS} ${QT_LIBRARIES})
#endif ()

##-----------------------------------------------------------------------------
##  Linker flags
##-----------------------------------------------------------------------------
set (PLASTIMATCH_LDFLAGS "${OPENMP_LDFLAGS}")
if (PLM_USE_GPU_PLUGINS AND WIN32 AND NOT CYGWIN AND NOT MINGW)
  set (PLASTIMATCH_LDFLAGS
 "${PLASTIMATCH_LDFLAGS} /DELAYLOAD:plmregistercuda.dll /DELAYLOAD:plmreconstructcuda.dll")
endif ()

if (PLM_CONFIG_NOMANIFEST AND WIN32)
  set (PLASTIMATCH_LDFLAGS "${PLASTIMATCH_LDFLAGS} /MANIFEST:NO")
endif ()

##-----------------------------------------------------------------------------
##  Include directories
##-----------------------------------------------------------------------------
include_directories (BEFORE ${CMAKE_BINARY_DIR})
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/base)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/cli)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/clp)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/dose)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/cuda)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/opencl)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/qt)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/reconstruct)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/reconstruct/cuda)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/register)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/register/cuda)
# GCS 2013-09-11.  Disable scripting, because it doesn't yet support
#   smart pointers for registration.
# include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/script)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/segment)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/sys)
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/util)

include_directories (BEFORE ${CMAKE_CURRENT_BINARY_DIR})
include_directories (AFTER ${ITK_INCLUDE_DIRS})
include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight)
include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight/DiffeomorphicDemons)
include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight/FastSymmetricForces)
include_directories (AFTER ${PLM_SOURCE_DIR}/libs/demons_itk_insight/LOGDomainDemons)
include_directories (AFTER ${PLM_SOURCE_DIR}/libs/nSIFT)
include_directories (AFTER ${DLIB_INCLUDE_DIR})
include_directories (AFTER ${LIBLBFGS_INCLUDE_DIR})
include_directories (AFTER ${MSINTTYPES_INCLUDE_DIR})
include_directories (AFTER ${RANSAC_INCLUDE_DIRS})

if (${PLM_CONFIG_USE_PATCHED_ITK})
  include_directories (AFTER ${CMAKE_SOURCE_DIR}/libs/itk-3.20.0)
endif ()

if (CUDA_FOUND)
  include_directories (AFTER ${CUDA_INCLUDE_DIRS})
endif ()
if (DCMTK_FOUND)
  include_directories (AFTER ${DCMTK_INCLUDE_DIRS})
endif ()
if (FFTW_FOUND)
  include_directories (BEFORE ${FFTW_INCLUDE_DIR})
  link_directories (${FFTW_DIR})
endif ()
if (KAZE_FOUND)
  include_directories (AFTER ${KAZE_INCLUDE_DIR})
endif ()
if (MATLAB_FOUND)
  include_directories (AFTER ${MATLAB_INCLUDE_DIRS})
endif ()
if (NLOPT_FOUND)
  include_directories (AFTER ${NLOPT_INCLUDE_DIR})
endif ()
if (OPENCL_FOUND)
  include_directories (BEFORE ${OPENCL_INCLUDE_DIRS})
endif ()
if (PANTHEIOS_FOUND)
  include_directories (AFTER ${STLSOFT_INCLUDE_DIR})
  include_directories (AFTER ${PANTHEIOS_INCLUDE_DIR})
endif ()
#if (QT4_FOUND)
#  if (QT_QTGUI_FOUND)
#    include_directories (AFTER ${QT_QTGUI_INCLUDE_DIR})
#  endif ()
#  if (QT_QTSQL_FOUND)
#    include_directories (AFTER ${QT_QTSQL_INCLUDE_DIR})
#  endif ()
#endif ()
if (RAPIDJSON_FOUND)
    include_directories (AFTER ${RAPIDJSON_INCLUDE_DIR})
endif ()
if (SQLITE_FOUND)
  include_directories (AFTER ${SQLITE_INCLUDE_DIR})
endif ()
if (LIBYAML_FOUND)
  include_directories (AFTER ${LIBYAML_INCLUDE_DIR})
endif ()

##-----------------------------------------------------------------------------
##  CONFIGURE INCLUDE FILES
##-----------------------------------------------------------------------------
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sys/plm_config.h.in
  ${CMAKE_BINARY_DIR}/plm_config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sys/plm_version.h.in
  ${CMAKE_BINARY_DIR}/plm_version.h)

##-----------------------------------------------------------------------------
## Option to generate .clang_complete for hip Vim users using clang_complete
##-----------------------------------------------------------------------------
if (PLM_CONFIG_CLANG_COMPLETE)
  get_property(inc_dirs DIRECTORY PROPERTY INCLUDE_DIRECTORIES)
  set (file_clang_complete "${CMAKE_SOURCE_DIR}/src/plastimatch/.clang_complete")
  foreach (arg ${inc_dirs})
    set (inc_args "${inc_args} -I${arg}\n")
  endforeach ()
  file (WRITE "${file_clang_complete}" "${inc_args}")
  message (STATUS "Generated ${file_clang_complete}")
endif ()

##-----------------------------------------------------------------------------
##  Do we have prerequisites for viscous code?
##-----------------------------------------------------------------------------
set (PLM_BUILD_VISCOUS FALSE)
if (PLM_CONFIG_ENABLE_VISCOUS
    AND CUDA_FOUND AND CUDA_SDK_ROOT_DIR AND THRUST_FOUND)
  set (PLM_BUILD_VISCOUS TRUE)
endif ()


##  Specify which libraries of plastimatch should be built
if (PLM_CONFIG_LIBRARY_BUILD)
else ()
  set (PLMLIB_CONFIG_ENABLE_CLI true)

=== src/plastimatch/base/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_base)

configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/plmbase_config.h.in
    ${CMAKE_BINARY_DIR}/plmbase_config.h
)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (AFTER ${NKIDECOMPRESS_INCLUDE_DIR})

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (PLMBASE_LIBRARY_SRC
  aperture.cxx aperture.h
  astroid_dose.cxx astroid_dose.h
  bspline_header.cxx bspline_header.h
  bspline_interpolate.cxx bspline_interpolate.h
  bspline_warp.cxx bspline_warp.h
  bspline_xform.cxx bspline_xform.h
  bspline_xform_legacy.cxx bspline_xform_legacy.h
  clamp.h
  cxt_extract.cxx cxt_extract.h
  cxt_io.cxx cxt_io.h
  dicom_probe.cxx dicom_probe.h
  dicom_util.cxx dicom_util.h
  dicom.dic   # How to make sure this gets installed?
  direction_cosines.cxx direction_cosines.h
  direction_matrices.cxx direction_matrices.h
  exchkeys.cxx
  float_pair_list.cxx float_pair_list.h
  gaussian.cxx gaussian.h
  hnd_io.cxx hnd_io.h
  hnd_io_p.h
  image_stats.cxx image_stats.h
  interpolate.cxx interpolate.h
  interpolate_macros.h
  itkAndConstantToImageFilter.h
  itkClampCastImageFilter.txx itkClampCastImageFilter.h
  itk_bbox.cxx itk_bbox.h
  itk_dicom_load.cxx itk_dicom_load.h
  itk_dicom_save.cxx itk_dicom_save.h
  itk_directions.cxx itk_directions.h
  itk_image.cxx itk_image.h
  itk_image_accumulate.cxx itk_image_accumulate.h
  itk_image_cast.cxx itk_image_cast.h
  itk_image_clone.cxx itk_image_clone.h
#  itk_image_conv.cxx (broken)
  itk_image_create.cxx itk_image_create.h
  itk_image_header_compare.cxx itk_image_header_compare.h
  itk_image_load.txx itk_image_load.h
  itk_image_load_char.cxx
  itk_image_load_double.cxx
  itk_image_load_float.cxx
  itk_image_load_int32.cxx
  itk_image_load_short.cxx
  itk_image_load_uchar.cxx
  itk_image_load_uint32.cxx
  itk_image_load_ushort.cxx
  itk_image_load_vec.cxx
  itk_image_origin.cxx itk_image_origin.h
  itk_image_region.cxx itk_image_region.h
  itk_image_save.cxx itk_image_save.h
  itk_image_scale.cxx itk_image_scale.h
  itk_image_stats.cxx itk_image_stats.h
  itk_image_type.h
  itk_metadata.cxx itk_metadata.h
  itk_point.h
  itk_pointset.cxx itk_pointset.h
  itk_resample.cxx itk_resample.h
  itk_volume_header.cxx itk_volume_header.h
  itk_warp.cxx itk_warp.h
  make_string.h
  mc_dose.cxx mc_dose.h
  metadata.cxx metadata.h
  mha_io.cxx mha_io.h
  nki_io.cxx nki_io.h
  parameter_parser.cxx parameter_parser.h
  plm_file_format.cxx plm_file_format.h
  plm_image.cxx plm_image.h
  plm_image_p.h
  plm_image_convert.cxx
  plm_image_header.cxx plm_image_header.h
  plm_image_set.cxx plm_image_set.h
  plm_image_type.cxx plm_image_type.h
  plm_itk.h
  plm_uid_prefix.h
  plm_warp.cxx plm_warp.h
  pointset.cxx pointset.h
  pointset_warp.cxx pointset_warp.h
  proj_image.cxx proj_image.h
  proj_image_dir.cxx proj_image_dir.h
  proj_matrix.cxx proj_matrix.h
  proj_volume.cxx proj_volume.h
  pwlut.cxx pwlut.h
  rasterize_slice.cxx rasterize_slice.h
  rasterizer.cxx rasterizer.h
  raw_pointset.cxx raw_pointset.h
  ray_data.h
  ray_trace.h
  ray_trace_callback.h
  ray_trace_probe.cxx
  ray_trace_probe.h
  ray_trace_uniform.cxx
  rpl_volume.cxx rpl_volume.h
  rpl_volume_lut.cxx rpl_volume_lut.h
  rtds_dcmtk.cxx
  rtds_gdcm.cxx
  rt_study.cxx rt_study.h
  rt_study_p.h
  rt_study_metadata.cxx rt_study_metadata.h
  rtog_io.cxx
  rtss.cxx rtss.h
  rtss_contour.cxx rtss_contour.h
  rtss_roi.cxx rtss_roi.h
  rtplan.cxx rtplan.h
  rtplan_beam.cxx rtplan_beam.h
  rtplan_control_pt.cxx rtplan_control_pt.h
  segmentation.cxx segmentation.h
  slice_extract.cxx slice_extract.h
  slice_list.cxx slice_list.h
  ss_img_extract.cxx ss_img_extract.h
  ss_list_io.cxx ss_list_io.h
  threading.h
  thumbnail.cxx thumbnail.h
  vf.cxx vf.h
  vf_convolve.cxx vf_convolve.h
  vf_jacobian.cxx vf_jacobian.h
  vf_stats.cxx vf_stats.h
  volume.cxx volume.h
  volume_boundary_behavior.h
  volume_conv.cxx volume_conv.h
  volume_fill.cxx volume_fill.h
  volume_gaussian.cxx volume_gaussian.h
  volume_grad.cxx volume_grad.h
  volume_header.cxx volume_header.h
  volume_limit.cxx volume_limit.h
  volume_macros.h
  volume_resample.cxx volume_resample.h
  volume_stats.cxx volume_stats.h
  xform.cxx xform.h
  xform_convert.cxx xform_convert.h
  xform_legacy.cxx xform_legacy.h
  xform_point.cxx xform_point.h
  xio_ct.cxx xio_ct.h
  xio_ct_transform.cxx xio_ct_transform.h
  xio_demographic.cxx xio_demographic.h
  xio_dir.cxx xio_dir.h
  xio_dose.cxx xio_dose.h
  xio_patient.cxx xio_patient.h
  xio_plan.cxx xio_plan.h
  xio_structures.cxx xio_structures.h
  xio_studyset.cxx xio_studyset.h
  xpm.cxx xpm.h xpm_p.h
  )

if (PLM_DCM_USE_GDCM1)
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    gdcm1_dose.cxx gdcm1_dose.h
    gdcm1_file.cxx gdcm1_file.h
    gdcm1_rdd.cxx gdcm1_rdd.h
    gdcm1_rtss.cxx gdcm1_rtss.h
    gdcm1_series.cxx gdcm1_series.h
    gdcm1_series_helper_2.cxx gdcm1_series_helper_2.h
    gdcm1_util.cxx gdcm1_util.h
    )
endif ()

if (PLM_DCM_USE_GDCM2)
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    gdcm2_util.cxx gdcm2_util.h
    )
endif ()

if (PLM_DCM_USE_DCMTK)
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    dcmtk_config.h
    dcmtk_file.cxx dcmtk_file.h
    dcmtk_image.cxx
    dcmtk_metadata.cxx dcmtk_metadata.h
    dcmtk_module.cxx dcmtk_module.h
    dcmtk_rdd.cxx dcmtk_rdd.h
    dcmtk_rtdose.cxx dcmtk_rtdose.h
    dcmtk_rtss.cxx dcmtk_rtss.h
    dcmtk_rtplan.cxx dcmtk_rtplan.h
    dcmtk_rt_study.cxx dcmtk_rt_study.h
    dcmtk_rt_study_p.cxx dcmtk_rt_study_p.h
    dcmtk_series.cxx dcmtk_series.h
    dcmtk_series_map.h
    dcmtk_sro.cxx dcmtk_sro.h
    dcmtk_uid.cxx dcmtk_uid.h
    dcmtk_util.cxx dcmtk_util.h
    )
endif ()

if (PLM_CONFIG_LEGACY_RAY_TRACE_EXACT)
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    ray_trace_exact_legacy.cxx
    )
else ()
  set (PLMBASE_LIBRARY_SRC
    ${PLMBASE_LIBRARY_SRC}
    ray_trace_exact.cxx
    )
endif ()

set (PLMBASE_LIBRARY_HEADERS
  "${CMAKE_BINARY_DIR}/plmbase_config.h"
  )
foreach (ARG ${PLMBASE_LIBRARY_SRC})
  string (REGEX MATCH ".*\\.h$" TMP "${ARG}")
  if (TMP)
    list (APPEND PLMBASE_LIBRARY_HEADERS "${TMP}")
  endif ()
endforeach ()

##-----------------------------------------------------------------------------
##  LIBRARY DEPENDENCIES
##-----------------------------------------------------------------------------
set (PLMBASE_LIBRARY_DEPENDENCIES
  ${ITK_LIBRARIES}
  nkidecompress
  plmsys
  )
if (DCMTK_FOUND)
  set (PLMBASE_LIBRARY_DEPENDENCIES
    ${PLMBASE_LIBRARY_DEPENDENCIES}
    ${DCMTK_LIBRARIES})
endif ()

##-----------------------------------------------------------------------------
##  SPECIAL BUILD RULES: OpenMP & SSE2
##-----------------------------------------------------------------------------
if (OPENMP_FOUND)
  set (PLMBASE_LIBRARY_LDFLAGS "${OPENMP_LDFLAGS}")
  set_source_files_properties (bspline_warp.cxx
    PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
  set_source_files_properties (volume_conv.cxx
    PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
endif ()

if (SSE2_FOUND)
  plm_set_sse2_flags (bspline_warp.cxx)
endif ()

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
plm_add_library (
  plmbase
  "${PLMBASE_LIBRARY_SRC}"
  "${PLMBASE_LIBRARY_DEPENDENCIES}"
  "${PLMBASE_LIBRARY_LDFLAGS}"
  "${PLASTIMATCH_INCLUDE_DIRECTORIES}"
  "${PLMBASE_LIBRARY_HEADERS}"
  )

=== src/plastimatch/cli/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_cli)

configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/plmcli_config.h.in
    ${CMAKE_BINARY_DIR}/plmcli_config.h
)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (AFTER ${LUA_INCLUDE_DIR})

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
#set (PLMCLP_LIBRARY_SRC
#  plm_clp.cxx plm_clp.h
#  )

set (PLASTIMATCH_SRC
  pcmd_add.cxx 
  pcmd_adjust.cxx 
  pcmd_autolabel_train.cxx 
  pcmd_autolabel.cxx 
  pcmd_bbox.cxx pcmd_bbox.h
  pcmd_benchmark.cxx 
  pcmd_boundary.cxx pcmd_boundary.h
  pcmd_compare.cxx 
  pcmd_compose.cxx 
  pcmd_crop.cxx 
  pcmd_dice.cxx 
  pcmd_diff.cxx 
  pcmd_dmap.cxx
  pcmd_dose.cxx pcmd_dose.h
  pcmd_drr.cxx 
  pcmd_dvh.cxx 
  pcmd_filter.cxx
  pcmd_gamma.cxx
  pcmd_header.cxx 
  pcmd_jacobian.cxx
  pcmd_mabs.cxx 
  pcmd_mask.cxx 
  pcmd_maximum.cxx
  pcmd_ml_convert.cxx pcmd_ml_convert.h 
  pcmd_multiply.cxx
  pcmd_probe.cxx 
  pcmd_register.cxx pcmd_register.h 
  pcmd_resample.cxx 
  pcmd_scale.cxx
#  pcmd_script.cxx 
  pcmd_segment.cxx 
  pcmd_sift.cxx
  pcmd_stats.cxx 
  pcmd_synth.cxx 
  pcmd_synth_vf.cxx 
  pcmd_threshold.cxx
  pcmd_thumbnail.cxx 
  pcmd_union.cxx
  pcmd_vf_invert.cxx pcmd_vf_invert.h
  pcmd_warp.cxx 
  pcmd_warp_dij.cxx 
  pcmd_warp_pointset.cxx 
  pcmd_xio_dvh.cxx 
  pcmd_xf_convert.cxx 
  plastimatch_main.cxx
  )

set (LANDMARK_WARP_SRC
  landmark_warp_main.cxx
  )

set (DRR_SRC
  drr_main.cxx 
  drr_opts.cxx
  )

set (PLM_CLI_LIBRARIES ${PLASTIMATCH_LIBS} plmclp)

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
#plm_add_library (
#  plmclp
#  "${PLMCLP_LIBRARY_SRC}" 
#  ""
#  "")
#add_library (plmclp STATIC ${PLMCLP_LIBRARY_SRC})
plm_add_executable_v3 (plastimatch "${PLASTIMATCH_SRC}"
  "" "${PLM_CLI_LIBRARIES}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_ALWAYS})
plm_add_executable_v3 (landmark_warp "${LANDMARK_WARP_SRC}" 
  "" "${PLM_CLI_LIBRARIES}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_ALWAYS})
plm_add_executable_v3 (drr "${DRR_SRC}" 
  "" "${PLM_CLI_LIBRARIES}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_ALWAYS})

=== src/plastimatch/standalone/CMakeLists.txt ===
##-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_standalone)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories (BEFORE ${CMAKE_CURRENT_BINARY_DIR})
include_directories (AFTER ${INIH_INCLUDE_DIR})

set (XVI_ARCHIVE_LIBRARIES 
    ${PLASTIMATCH_LIBS}
    inih
    )

##-----------------------------------------------------------------------------
##  SOURCE FILES
##-----------------------------------------------------------------------------
set (BRAGG_CURVE_SRC
  bragg_curve_main.cxx 
  bragg_curve_opts.cxx
  )
set (SOBP_SRC
  sobp_main.cxx 
  )
set (BSPLINE_SRC
  bspline_main.cxx 
  bspline_opts.cxx
  )
set (CHECK_GRAD_SRC
  check_grad.cxx
  )
set (COMPUTE_DISTANCE_SRC
  compute_distance.cxx
  closest_point.cxx 
  read_obj.cxx
  )
set (CUDA_PROBE_SRC
  cuda_probe_main.cxx
  )
set (DEMONS_SRC
  demons_main.cxx 
  demons_opts.cxx
  )
set (DICOM_INFO_SRC
  dicom_info.cxx
  )
set (DICOM_UID_SRC
  dicom_uid_main.cxx
  )
set (DLIB_TRAIN_SRC 
  dlib_train.cxx
  )
set (FDK_SRC
  fdk_main.cxx 
  fdk_opts.cxx
)
set (HND_TO_PFM_SRC
  hnd_to_pfm.cxx 
  )
set (LANDMARK_DIFF_SRC
  landmark_diff_main.cxx
  )
set (MERGE_VFS_SRC
  merge_vector_fields.cxx
  )
set (MEX_DRR_SRC
  mex_drr.c
  )
set (MHA_TO_RAW_SRC
  mha_to_raw.c
  )
#set (MHA_TO_RTOG_DOSE_SRC
#  mha_to_rtog_dose.cxx
#  )
set (OPENCL_PROBE_SRC
  opencl_probe_main.c
  opencl_probe.cxx
  )
if (OPENCL_FOUND)
  plm_add_opencl_file (OPENCL_PROBE_SRC opencl_probe.cl)
endif ()
set (RAW_TO_MHA_SRC
  raw_to_mha.c
  )
#set (RTOG_TO_MHA_SRC
#  rtog_to_mha.cxx
#  )
set (VISCOUS_SRC
  viscous.cxx
  )
set (WED_SRC
  wed_main.cxx
  )
set (XVI_ARCHIVE_SRC
    xvi_archive.cxx
    )
set (GROUP_ADD_SRC
  group_add.cxx
  )
set (FILTER_SRC
  filter.cxx
  )
set (GAMMA_THRESH_SRC
  Gamma_Thresh.cxx
  )
set (FLIP_IMAGE_SRC
  flip_image.cxx
  )
set (DECOMP_VECTOR_SRC
  decomp_vector.cxx
  )
set (TEMPLATE_SRC
  Template.cxx
  )
set (FIND_CENTER_SRC
  find_center.cxx
  )
set (SHUFFLE_MHA_SRC
  shuffle_mha_main.cxx
  )
set (VF_INVERT_SRC
  vf_invert_main.cxx
  )
set (XF_TO_EMPIREFMT_SRC
    xf_to_empirefmt.cxx
    )
set (CMD_PROMPT_LAUNCHER_SRC
    cmd_prompt_launcher.cxx
    )
if (QT4_FOUND)
set(nki2mha_converter_SRC
	nki2mha_converter_main.cpp
	nki2mha_converter.cpp 	nki2mha_converter.h)

QT4_WRAP_CPP(nki2mha_converter_SRC
	nki2mha_converter.h)
QT4_WRAP_UI(nki2mha_converter_SRC
	nki2mha_converter.ui)
QT4_ADD_RESOURCES (nki2mha_converter_SRC
	nki2mha_converter.qrc)

	
set(GAMMA_GUI_BASE_SRC
	gamma_gui_main.cpp	
	gamma_gui.cpp
	gamma_gui.h
	qyklabel.h
	qyklabel.cpp
	DlgGammaView.h
	DlgGammaView.cxx
	YK16GrayImage.cxx
	YK16GrayImage.h	
	qt_util.h
	qt_util.cxx
	qcustomplot.h
	qcustomplot.cpp
	yk_config.h)

QT4_WRAP_CPP(GAMMA_GUI_MOC
	DlgGammaView.h
	qyklabel.h
	qcustomplot.h
	gamma_gui.h)
	
QT4_WRAP_UI(GAMMA_GUI_UI
	gamma_gui.ui
	DlgGammaView.ui)

set(GAMMA_GUI_SRC
    ${GAMMA_GUI_BASE_SRC}
    ${GAMMA_GUI_MOC}
    ${GAMMA_GUI_UI}
    )

# Don't compile the files which include generated headers until
# generated headers are built.
set_source_files_properties (${GAMMA_GUI_BASE_SRC}
    PROPERTIES OBJECT_DEPENDS "${GAMMA_GUI_UI}")
    
set(REGISTER_GUI_SRC
  register_gui_main.cpp
  register_gui.cpp
  register_gui.h
  qyklabel.h
  qyklabel.cpp
  YK16GrayImage.cxx
  YK16GrayImage.h
  qt_util.h
  qt_util.cxx
  qcustomplot.h
  qcustomplot.cpp
  yk_config.h
  YKThreadRegi.h
  YKThreadRegi.cpp
  )

QT4_WRAP_CPP(REGISTER_GUI_SRC	
  qyklabel.h
  qcustomplot.h
  register_gui.h
  YKThreadRegi.h)
QT4_WRAP_UI(REGISTER_GUI_SRC
  register_gui.ui
  )

set(BEAMDATA_GEN_GUI_SRC	
	beamdata_gen_gui.h
	beamdata_gen_gui.cpp
	beamdata_gen_gui_main.cpp
	qyklabel.h
	qyklabel.cpp
	YK16GrayImage.cxx
	YK16GrayImage.h
	qt_util.h
	qt_util.cxx
	qcustomplot.h
	qcustomplot.cpp
	yk_config.h
	BeamDataRFA.cxx
	BeamDataRFA.h
	)

QT4_WRAP_CPP(BEAMDATA_GEN_GUI_SRC	
	beamdata_gen_gui.h
	qyklabel.h
	qcustomplot.h
	beamdata_gen_gui.h
	)
QT4_WRAP_UI(BEAMDATA_GEN_GUI_SRC
	beamdata_gen_gui.ui
	)

endif()

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
if (ITK_FOUND)
  plm_add_executable_v3 (compute_distance "${COMPUTE_DISTANCE_SRC}" 
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  plm_add_executable_v3 (dicom_info "${DICOM_INFO_SRC}"
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  plm_add_executable_v3 (landmark_diff "${LANDMARK_DIFF_SRC}" 
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  plm_add_executable_v3 (merge_vfs  "${MERGE_VFS_SRC}"
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  plm_add_executable_v3 (shuffle_mha "${SHUFFLE_MHA_SRC}"
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  if (PLM_BUILD_VISCOUS)
    plm_add_executable_v3 (viscous "${VISCOUS_SRC}"
      "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  endif ()
  plm_add_executable_v3 (vf_invert "${VF_INVERT_SRC}"
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  plm_add_executable_v3 (wed "${WED_SRC}" 
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  if (PLM_DCM_USE_DCMTK)
    plm_add_executable_v3 (xvi_archive "${XVI_ARCHIVE_SRC}" 
      "" "${XVI_ARCHIVE_LIBRARIES}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
  endif ()
  plm_add_executable_v3 (group_add "${GROUP_ADD_SRC}" 
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
endif ()

if (QT4_FOUND)
  set (QT4_INCLUDE_DIRS ${QT_QTGUI_INCLUDE_DIR}
    ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})
  set (QT4_LIBRARIES ${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY})
  plm_add_executable_v3 (nki2mha_converter "${nki2mha_converter_SRC}"
    "${QT4_INCLUDE_DIRS}" "${PLASTIMATCH_LIBS};${QT4_LIBRARIES}"
    "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
  if (DCMTK_FOUND)
    plm_add_executable_v3 (gamma_gui "${GAMMA_GUI_SRC}"
      "${QT4_INCLUDE_DIRS}" "${PLASTIMATCH_LIBS};${QT4_LIBRARIES}"
      "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
    plm_add_executable_v3 (beamdata_gen_gui "${BEAMDATA_GEN_GUI_SRC}" 
      "${QT4_INCLUDE_DIRS}" "${PLASTIMATCH_LIBS};${QT4_LIBRARIES}"
      "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
  endif ()
  plm_add_executable_v3 (register_gui "${REGISTER_GUI_SRC}" 
    "${QT4_INCLUDE_DIRS}" "${PLASTIMATCH_LIBS};${QT4_LIBRARIES}"
    "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
endif()

plm_add_executable_v3 (bspline "${BSPLINE_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
plm_add_executable_v3 (check_grad "${CHECK_GRAD_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
plm_add_executable_v3 (demons "${DEMONS_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
plm_add_executable_v3 (dlib_train "${DLIB_TRAIN_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
plm_add_executable_v3 (hnd_to_pfm "${HND_TO_PFM_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
plm_add_executable_v3 (bragg_curve "${BRAGG_CURVE_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
plm_add_executable_v3 (sobp "${SOBP_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})

plm_add_executable_v3 (fdk "${FDK_SRC}" 
  "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_ALWAYS})
if (CUDA_FOUND)
  plm_add_executable_v3 (cuda_probe "${CUDA_PROBE_SRC}" 
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
endif ()

# if (MATLAB_FOUND)
#   mex_target (mex_drr "${MEX_DRR_SRC}"
#   "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}")
# endif ()

if (OPENCL_FOUND)
  plm_add_executable_v3 (opencl_probe "${OPENCL_PROBE_SRC}"
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
endif ()

# dicom_uid requires dcmtk
if (DCMTK_FOUND)
  plm_add_executable_v3 (dicom_uid "${DICOM_UID_SRC}" 
    "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_IF_NOT_DEBIAN})
endif ()

=== src/plastimatch/test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
##  See COPYRIGHT.TXT and LICENSE.TXT for copyright and license information
##-----------------------------------------------------------------------------
project (src_plastimatch_test)

include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

if (CUDA_FOUND)
  add_subdirectory (cuda)
  include_directories (BEFORE "${CMAKE_CURRENT_SOURCE_DIR}/cuda")
endif ()

##-----------------------------------------------------------------------------
##  CMAKE FLAGS
##-----------------------------------------------------------------------------
option (PLM_CONFIG_BUILD_TEST_PROGRAMS
    "Build extra test program executables" OFF)

##-----------------------------------------------------------------------------
##  BUILD TARGETS
##-----------------------------------------------------------------------------
# Test executable -- plastimatch api
if (PLM_CONFIG_BUILD_TEST_PROGRAMS)
    plm_add_executable_v3 (api_test api_test.cxx 
      "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})

    # Test executable -- c++ properties
    plm_add_executable_v3 (cpp_eps_test cpp_eps_test.cxx
      "" "" "" ${INSTALL_NEVER})
    plm_add_executable_v3 (cpp_floating_point_test cpp_floating_point_test.cxx
      "" "" "" ${INSTALL_NEVER})
    plm_add_executable_v3 (cpp_limits_test cpp_limits_test.cxx
      "" "" "" ${INSTALL_NEVER})
    plm_add_executable_v3 (cpp_overflow_test cpp_overflow_test.cxx
      "" "" "" ${INSTALL_NEVER})
    plm_add_executable_v3 (cpp_template_test cpp_template_test.cxx
      "" "" "" ${INSTALL_NEVER})
    plm_add_executable_v3 (cpp_sizeof_test cpp_sizeof_test.cxx
      "" "" "" ${INSTALL_NEVER})

    # Test executable -- dcmtk
    if (ITK_FOUND AND DCMTK_FOUND)
      plm_add_executable_v3 (dcmtk_test dcmtk_test.cxx
	"" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
      plm_add_executable_v3 (rtplan_test rtplan_test.cxx 
	"" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
    endif ()

    # Test executable -- dlib
    plm_add_executable_v3 (dlib_test dlib_test.cxx
      "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
    plm_add_executable_v3 (dlib_thread_test dlib_thread_test.cxx
      "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})

    # Test executable -- gabor_test
    plm_add_executable_v3 (gabor_test gabor_test.cxx 
      "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})

    # Test executables -- itk
    if (ITK_FOUND)
      plm_add_executable_v3 (itk_test itk_test.cxx
	"" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
      plm_add_executable_v3 (itk_test_directions itk_test_directions.cxx
	"" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
      plm_add_executable_v3 (itk_test_threads itk_thread_test.cxx
	"" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
    endif ()

    # Test executable -- libyaml
    if (LIBYAML_FOUND)
      plm_add_executable_v3 (libyaml_test libyaml_test.cxx
	"" "${LIBYAML_LIBRARIES}" "" ${INSTALL_NEVER})
    endif ()

    # Test executable -- matlab
    if (MATLAB_FOUND)
	file (WRITE "${CMAKE_BINARY_DIR}/compile_mex_test.m"
	    "mex \"${CMAKE_SOURCE_DIR}/mex_test.c\";exit;\n")
	file (WRITE "${CMAKE_BINARY_DIR}/mex_test.cmake"
	    "EXECUTE_PROCESS (COMMAND ${MATLAB_EXE} -nosplash -nodesktop -nojvm
            -r compile_mex_test
            RESULT_VARIABLE RESULT
            OUTPUT_VARIABLE STDOUT
            ERROR_VARIABLE STDERR)\n")
	add_custom_command (
	    OUTPUT "${CMAKE_BINARY_DIR}/mex_test${MATLAB_MEXEXT}"
	    COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/mex_test.cmake"
	    DEPENDS "${CMAKE_SOURCE_DIR}/mex_test.c")
	add_custom_target (mat_mex_test
	    DEPENDS "${CMAKE_BINARY_DIR}/mex_test${MATLAB_MEXEXT}")
	target_link_libraries (mex_test ${MATLAB_LIBRARIES})
    endif ()

    # Test executable -- octave
    if (OCTAVE_FOUND)
	add_custom_command (
	    OUTPUT "${CMAKE_BINARY_DIR}/mex_test.mex"
	    COMMAND ${OCTAVE_MKOCTFILE} --mex 
	    -o "${CMAKE_BINARY_DIR}/mex_test.mex" 
	    "${CMAKE_SOURCE_DIR}/mex_test.c"
	    DEPENDS "${CMAKE_SOURCE_DIR}/mex_test.c")
	add_custom_target (oct_mex_test
	    DEPENDS "${CMAKE_BINARY_DIR}/mex_test.mex")
    endif ()

    # Test executable -- nlopt
    if (NLOPT_FOUND)
      set (NLOPT_TEST_LIBS ${GPUIT_LIBRARIES} ${NLOPT_LIBRARIES})
      plm_add_executable_v3 (nlopt_test nlopt_test.c
	"" "${NLOPT_TEST_LIBS}" "${OPENMP_LDFLAGS}" ${INSTALL_NEVER})
      set_target_properties (nlopt_test PROPERTIES LINKER_LANGUAGE CXX)
    endif ()

    # Test executable -- nm
    plm_add_executable_v3 (nelder_mead_test nelder_mead_test.cxx
      "" "${PLASTIMATCH_LIBS}" "${OPENMP_LDFLAGS}" ${INSTALL_NEVER})

    # Test executable -- opencl
    if (OPENCL_FOUND)
      set (OPENCL_TEST_SRC
	opencl_test.cxx opencl_test.h opencl_test.cl
	"${CMAKE_BINARY_DIR}/opencl_test.cl"
	)
      set (OPENCL_TEST_LIBS ${OPENCL_LIBRARIES} ${PLASTIMATCH_LIBS})
      plm_add_executable_v3 (opencl_test "${OPENCL_TEST_SRC}" 
	"" "${OPENCL_TEST_LIBS}" "" ${INSTALL_NEVER})

      # I don't yet know how to bundle the .cl file within the executable.
      # Therefore, copy the .cl into binary directory.
      add_custom_command (
	OUTPUT "${CMAKE_BINARY_DIR}/opencl_test.cl" 
	COMMAND ${CMAKE_COMMAND} "-E" "copy" 
	"${CMAKE_CURRENT_SOURCE_DIR}/opencl_test.cl" 
	"${CMAKE_BINARY_DIR}/opencl_test.cl" 
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/opencl_test.cl")
    endif ()

    # Test executable -- openmp
    if (OPENMP_FOUND)
      set_source_files_properties (openmp_test.cxx
	PROPERTIES COMPILE_FLAGS ${OPENMP_FLAGS})
      plm_add_executable_v3 (openmp_test openmp_test.cxx
	"" "${PLASTIMATCH_LIBS}" "${OPENMP_LDFLAGS}" ${INSTALL_NEVER})
    endif ()

    # Test executable -- plm
    plm_add_executable_v3 (plm_restart_test plm_restart_test.cxx
      "" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})

    # Test executable -- qt
    if (Qt5_FOUND)
      set (QT5_TEST_LIBRARIES Qt5::Network Qt5::Widgets Qt5::Gui Qt5::Core)
      plm_add_executable_v3 (qt5_test qt_test.cxx
	"" "${QT5_TEST_LIBRARIES}" "" ${INSTALL_NEVER})
    endif ()
    if (QT4_FOUND)
      set (QT4_TEST_INCLUDES ${PLASTIMATCH_INCLUDES} ${QT_QTGUI_INCLUDE_DIR}
	${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})
      set (QT4_TEST_LIBRARIES ${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY})
      plm_add_executable_v3 (qt4_test qt_test.cxx
	"${QT4_TEST_INCLUDES}" "${QT4_TEST_LIBRARIES}" "" ${INSTALL_NEVER})
    endif ()

    # Test executable -- ransac
    plm_add_executable_v3 (ransac_test ransac_test.cxx
      "" "${PLASTIMATCH_LIBS}" "${GPUIT_EXE_LDFLAGS}" ${INSTALL_NEVER})

    # Test executable -- rapidjson
    if (RAPIDJSON_FOUND)
      plm_add_executable_v3 (rapidjson_test rapidjson_test.cxx
	"" "${PLASTIMATCH_LIBS}" "${PLASTIMATCH_LDFLAGS}" ${INSTALL_NEVER})
    endif ()

    # Test executable -- smart pointers I
    ## find_package (TR1)
    plm_add_executable_v3 (smartp_test_i smartp_test_i.cxx
      "" "${PLASTIMATCH_LIBS}" "${GPUIT_EXE_LDFLAGS}" ${INSTALL_NEVER})

    # Test executable -- smart pointers II
    plm_add_executable_v3 (smartp_test_ii smartp_test_ii.cxx
      "" "${PLASTIMATCH_LIBS}" "${GPUIT_EXE_LDFLAGS}" ${INSTALL_NEVER})
endif ()

=== debian/changelog ===
plastimatch (1.7.3+dfsg.1-1) unstable; urgency=medium

  [ Gregory C. Sharp ]
  * New upstream version

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5
  * Drop Build-Depends: libdlib18
  * Delete useless get-orig-source target

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Mon, 09 Jul 2018 16:28:37 -0400

=== debian/control ===
Source: plastimatch
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gregory C. Sharp <gregsharp.geo@yahoo.com>,
           Dominique Belhachemi <domibel@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               libblas-dev,
               libdcmtk-dev,
               libdlib-dev,
               libfftw3-dev,
               libgdcm2-dev,
               libinsighttoolkit4-dev,
               liblapack-dev,
               libpng-dev,
               libsqlite3-dev,
               libtiff-dev,
               uuid-dev,
               zlib1g-dev
Standards-Version: 4.1.5
Vcs-Browser: https://salsa.debian.org/med-team/plastimatch
Vcs-Git: https://salsa.debian.org/med-team/plastimatch.git
Homepage: http://plastimatch.org

Package: plastimatch
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: medical image reconstruction and registration
 Plastimatch is an open source software for deformable image
 registration. It is designed for high-performance volumetric
 registration of medical images, such as X-ray computed tomography (CT),
 magnetic resonance imaging (MRI), and positron emission tomography(PET).
 Software features include:
  * B-spline method for deformable image registration (GPU and multicore
    accelerated), including support for image masking, landmark penalties,
    and regularization
  * Demons method for deformable image registration (GPU accelerated)
  * Multi-atlas segmentation
  * ITK-based algorithms for translation, rigid, affine, multiple demons
    methods, and B-spline registration
  * Pipelined, multi-stage registration framework with seamless conversion
    between most algorithms and transform types
  * Landmark-based deformable registration using thinplate splines for
    global registration
  * Landmark-based deformable registration using radial basis functions
    for local corrections
  * Broad support for 3D image file formats (using ITK), including DICOM,
    Nifti, NRRD, MetaImage, and Analyze
  * Extensive toolchain for radiotherapy research, including support for
    DICOM, DICOM-RT, DICOM SRO, XiO file format, gamma analysis, contour
    manipulation, contour overlap analysis, and vector field analysis
 Plastimatch also features two handy utilities which are not directly
 related to image registration:
  * FDK cone-beam CT reconstruction (GPU and multicore accelerated)
  * Digitally reconstructed radiograph (DRR) generation (GPU and multicore
    accelerated)

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

PACKAGE   = $(shell dh_listpackages)
TMP       = $(CURDIR)/debian/$(PACKAGE)

BUILD_DIR := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(CURDIR)/$(BUILD_DIR):$(TMP)/usr/lib
export LD_LIBRARY_PATH

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

# CMAKE_PREFIX_PATH is used when building against ITK 3.20
DEB_CMAKE_EXTRA_FLAGS += \
	-DCMAKE_PREFIX_PATH=/usr/lib/InsightToolkit \
        -DCMAKE_BUILD_TYPE:STRING=RELEASE \
        -DCMAKE_SKIP_RPATH:BOOL=ON \
        -DPLM_CONFIG_DEBIAN_BUILD:BOOL=ON \
        -DBUILD_SHARED_LIBS=ON \
        -DBUILD_TESTING:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
#Make the test suit fatal on supported arches
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 kfreebsd-amd64 kfreebsd-amd64))
	dh_auto_test
else
	dh_auto_test || true
endif

override_dh_auto_install:
	dh_auto_install
	rm -rfv $(TMP)/usr/lib/*.a
	rm -rfv $(TMP)/usr/lib/cmake
	rm -rfv $(TMP)/usr/include
